#ifndef _EXAMPLE_01_02_HPP_
#define _EXAMPLE_01_02_HPP_ 1

#include "DatabaseHeap.hpp"
#include "FixedString.hpp"
#include "NoLock.hpp"
#include "RockallTypes.hpp"
#include "Tree.hpp"

typedef DATABASE_HEAP HEAP_TYPE;
typedef FIXED_STRING<HEAP_TYPE,char,32> STRING;
typedef TREE<HEAP_TYPE,NO_LOCK,int,FILE_ADDRESS> INDEX1;
typedef TREE<HEAP_TYPE,NO_LOCK,STRING,FILE_ADDRESS> INDEX2;

typedef struct
  {
  INDEX1    Index1;
  INDEX2    Index2;
  }
ROOT;

typedef struct
  {
  int       Key1;
  STRING    Key2;
  STRING    Value1;
  STRING    Value2;
  }
ROW;
#endif