#ifdef ROCKALL_DB_EXAMPLES
#define main Example_03_07
#endif

#include "Example-03-04.hpp"
#include "PlacementNew.hpp"
#include "SingleThreadedHeap.hpp"

int main( void )
  {
  BASIC_CLASS *BasicClass;
  SINGLE_THREADED_HEAP Heap;

  if ( Heap.New( ((void**) & BasicClass),sizeof(BASIC_CLASS) ) )
    {
    PLACEMENT_NEW( BasicClass,BASIC_CLASS );

    // 'BASIC_CLASS' ready for use.

    PLACEMENT_DELETE( BasicClass,BASIC_CLASS );

    if ( ! Heap.Delete( BasicClass ) )
      { printf( "Delete fails\n" ); }
    }

  return 0;
  }

