#ifdef ROCKALL_DB_EXAMPLES
#define main Example_03_16
#endif

#include "DatabaseHeap.hpp"
#include "Example-03-04.hpp"
#include "RockallNew.hpp"
#include "RockallTypes.hpp"

int main( int Count,char *Argument[] )
  {
  DATABASE_HEAP Heap;

  if ( (Count == 2) && (Heap.CreateFile( Argument[1] )) )
    {
    if ( Heap.BeginTransaction() )
      {
      BASIC_CLASS *BasicClass;
      FILE_ADDRESS Address;

      if
            (
            (ROCKALL_NEW<BASIC_CLASS>::New( & Heap,& Address,& BasicClass ))
              &&
            (Heap.SetUserValue( 0,Address ))
            )
          {
          BasicClass -> Value = 1;

          Heap.EndTransaction( False );
          }
      else
          { Heap.EndTransaction( True ); }
      }

    Heap.CloseFile();
    }

  return 0;
  }

