#ifdef ROCKALL_DB_EXAMPLES
#define main Example_04_05
#endif

#include "AutomaticHeapScope.hpp"
#include "SingleThreadedHeap.hpp"

int main( int Count,char *Argument[] )
  {
  SINGLE_THREADED_HEAP Heap;
  AUTOMATIC_HEAP_SCOPE<SINGLE_THREADED_HEAP> Scope( & Heap );

  if ( (Count == 2) && (Scope.CreateFile( Argument[1] )) )
    {
    if ( Scope.BeginTransaction() )
      { return 1; }
    }

  return 0;
  }
