#ifdef ROCKALL_DB_EXAMPLES
#define main Example_04_07
#endif

#include "AutomaticHeapScope.hpp"
#include "FixedString.hpp"
#include "FlexibleString.hpp"
#include "RockallTypes.hpp"
#include "SingleThreadedHeap.hpp"

typedef SINGLE_THREADED_HEAP HEAP_TYPE;

int main( void )
  {
  HEAP_TYPE Heap;
  AUTOMATIC_HEAP_SCOPE<SINGLE_THREADED_HEAP> Scope( & Heap );
  FIXED_STRING<SINGLE_THREADED_HEAP,CHAR,64> String1 = "String1";
  FIXED_STRING<SINGLE_THREADED_HEAP,CHAR,64> String2 = "String2";
  FIXED_STRING<SINGLE_THREADED_HEAP,WCHAR,64> String3 = L"String3";
  FIXED_STRING<SINGLE_THREADED_HEAP,WCHAR,64> String4 = L"String4";
  FLEXIBLE_STRING<SINGLE_THREADED_HEAP,CHAR> String5 = "String5";
  FLEXIBLE_STRING<SINGLE_THREADED_HEAP,CHAR> String6 = "String6";
  FLEXIBLE_STRING<SINGLE_THREADED_HEAP,WCHAR> String7 = L"String7";
  FLEXIBLE_STRING<SINGLE_THREADED_HEAP,WCHAR> String8 = L"String8";
  CHAR String9[10] = "String9";
  WCHAR String10[10] = L"String10";

  if ( (String1 != String2) && (String1 != String9) )
    {
    String2 = String1;
    String2 = String3;
    String2 = String5;
    String2 = String7;
    String2 = String9;
    String2 = String10;

    String2 = String1;
    String2 += " & ";
    String2 += String1;
    String2 += " & ";
    String2 += String5;
    String2 += " & ";
    String2 += String9;
    }

  if ( (String3 != String4) && (String3 != String10) )
    {
    String4 = String1;
    String4 = String3;
    String4 = String5;
    String4 = String7;
    String4 = String9;
    String4 = String10;

    String4 = String3;
    String4 += L" & ";
    String4 += String3;
    String4 += L" & ";
    String4 += String7;
    String4 += L" & ";
    String4 += String10;
    }

  if ( (String5 != String6) && (String5 != String9) )
    {
    String6 = String1;
    String6 = String3;
    String6 = String5;
    String6 = String7;
    String6 = String9;
    String6 = String10;

    String6 = String5;
    String6 += " & ";
    String6 += String1;
    String6 += " & ";
    String6 += String5;
    String6 += " & ";
    String6 += String9;
    }

  if ( (String7 != String8) && (String7 != String10) )
    {
    String8 = String1;
    String8 = String3;
    String8 = String5;
    String8 = String7;
    String8 = String9;
    String8 = String10;

    String8 = String7;
    String8 += L" & ";
    String8 += String3;
    String8 += L" & ";
    String8 += String7;
    String8 += L" & ";
    String8 += String10;
    }

  return 0;
  }
