#ifdef ROCKALL_DB_EXAMPLES
#define main Example_05_05
#endif

#include "SingleThreadedHeap.hpp"
#include "Failure.hpp"
#include "RockallTypes.hpp"

int main( void )
  {
  SINGLE_THREADED_HEAP Heap;
  int *Data;

  if ( Heap.Feature( RockallTransactionalSupport ) )
    {
    if
        (
        (! Heap.BeginTransaction())
          ||
        (! Heap.New( ((void**) & Data),sizeof(int) ))
          ||
        (! Heap.EndTransaction())
        )
      { FAILURE( "Unable to allocate an int" ); }
    }
  else
    {
    if ( ! Heap.New( ((void**) & Data),sizeof(int) ) )
      { FAILURE( "Unable to allocate an int" ); }
    }

  return 0;
  }

