#ifdef ROCKALL_DB_EXAMPLES
#define main Example_06_08
#endif

#include "AutomaticHeapScope.hpp"
#include "SingleThreadedHeap.hpp"
#include "Stack.hpp"

typedef SINGLE_THREADED_HEAP HEAP_TYPE;

int main( int Count,char *Argument[] )
  {
  HEAP_TYPE Heap;
  AUTOMATIC_HEAP_SCOPE<HEAP_TYPE> Scope( & Heap );
  int Result = 1;

  if ( Count == 2 )
    {
    AUTOMATIC_HEAP_SCOPE<HEAP_TYPE> Scope2;

    STACK<HEAP_TYPE,NO_LOCK,int> Stack( & Scope2 );

    if ( Stack.PushValue( & Scope2,0 ) )
      { Result = 0; }
    }

  return Result;
  }