#ifdef ROCKALL_DB_EXAMPLES
#define main Example_06_18
#endif

#include <stdio.h>

#include "AutomaticHeapScope.hpp"
#include "RowSet.hpp"
#include "SingleThreadedHeap.hpp"

typedef SINGLE_THREADED_HEAP HEAP_TYPE;
typedef ROW_SET<HEAP_TYPE,NO_LOCK> SET_TYPE;

int main( void )
  {
  HEAP_TYPE Heap;
  AUTOMATIC_HEAP_SCOPE<HEAP_TYPE> Scope( & Heap );
  SET_TYPE RowSet( & Scope );

  if ( RowSet.Touch( & Scope ) )
    { printf( "End of example\n" ); }

  return 0;
  }
