#ifdef ROCKALL_DB_EXAMPLES
#define main Example_06_28
#endif

#include <stdio.h>

#include "AsynchronousCallbacks.hpp"
#include "DatabaseHeap.hpp"
#include "RockallTypes.hpp"

void AsynchronousFunction( int *Value )
  { printf( "Asynchronous Function value is %d\n",(*Value) ); }

int main( void )
  {
  DATABASE_HEAP Heap;
  ASYNCHRONOUS_CALLBACKS<int> Callbacks;
  int CPUs = ((int) Callbacks.NumberOfCPUs());
  int Count;

  for ( Count=0;Count < CPUs;Count ++ )
    { Callbacks.Schedule( AsynchronousFunction,Count ); }

  Callbacks.Sleep( 1 );

  Callbacks.WaitAll();

  return 0;
  }