#ifdef ROCKALL_DB_EXAMPLES
#define main Example_06_33
#endif

#include "SingleThreadedHeap.hpp"
#include "RockallDelete.hpp"
#include "RockallNew.hpp"
#include "RockallTypes.hpp"

int main( void )
  {
  SINGLE_THREADED_HEAP Heap;
  FILE_ADDRESS Address;
  int *Data;
  FILE_SIZE Space;

  if
      (
      ROCKALL_NEW<int>::New
          (
          & Heap,
          & Address,
          & Data,
          1,
          & Space,
          False,
          True
          )
      )
    {
    ROCKALL_DELETE<int>::Delete
      (
      & Heap,
      Address,
      1,
      True
      );
    }

  return 0;
  }

