#ifdef ROCKALL_DB_EXAMPLES
#define main Example_01_01
#endif

#include <stdio.h>
#include <string.h>

#include "DatabaseHeap.hpp"
#include "RockallNew.hpp"
#include "RockallTypes.hpp"

int main( int Count,char *Argument[] )
  {
  DATABASE_HEAP Heap;

  if ( (Count == 2) && (Heap.CreateFile( Argument[1] )) )
    {
    if ( Heap.BeginTransaction() )
      {
      FILE_ADDRESS Address;
      char (*Data)[16];

      if ( ROCKALL_NEW<char[16]>::New( & Heap,& Address,& Data ) )
        { strcpy( ((char*) Data),"Hello world !" ); }

      Heap.EndTransaction();
      }

    Heap.CloseFile();
    }

  return 0;
  }
