#ifdef ROCKALL_DB_EXAMPLES
#define main Example_03_08
#endif

#include "Example-03-04.hpp"
#include "RockallDelete.hpp"
#include "RockallNew.hpp"
#include "SingleThreadedHeap.hpp"

int main( void )
  {
  BASIC_CLASS *BasicClass;
  SINGLE_THREADED_HEAP Heap;

  if ( ROCKALL_NEW<BASIC_CLASS>::New( & Heap,& BasicClass ) )
    {
    // 'BASIC_CLASS' ready for use.

    if ( ! ROCKALL_DELETE<BASIC_CLASS>::Delete( & Heap,BasicClass ) )
      { printf( "Delete fails\n" ); }

    }

  return 0;
  }
