#ifdef ROCKALL_DB_EXAMPLES
#define main Example_03_11
#endif

#include "Example-03-09.hpp"
#include "RockallNew.hpp"
#include "SingleThreadedHeap.hpp"
#include "RockallTypes.hpp"

int main( void )
  {
  EXTENDED_CLASS *ExtendedClass;
  SINGLE_THREADED_HEAP Heap;

  if
      (
      ROCKALL_NEW<EXTENDED_CLASS>::New
        ( & Heap,& ExtendedClass,1,NULL,True )
      )
    {
    // 'EXTENDED_CLASS' ready for use.

    if ( ! Heap.Delete( ExtendedClass ) )
      { printf( "Delete fails\n" ); }
    }

  return 0;
  }

