#ifdef ROCKALL_DB_EXAMPLES
#define main Example_03_14
#endif

#include "DatabaseHeap.hpp"
#include "Example-03-04.hpp"
#include "RockallDelete.hpp"
#include "RockallNew.hpp"

int main( int Count,char *Argument[] )
  {
  DATABASE_HEAP Heap;

  if ( (Count == 2) && (Heap.CreateFile( Argument[1] )) )
    {
    if ( Heap.BeginTransaction() )
      {
      BASIC_CLASS *BasicClass;

      if ( ROCKALL_NEW<BASIC_CLASS>::New( & Heap,& BasicClass ) )
        {
        // 'BASIC_CLASS' ready for use.

        ROCKALL_DELETE<BASIC_CLASS>::Delete( & Heap,BasicClass );
        }

      Heap.EndTransaction();
      }

    Heap.CloseFile();
    }

  return 0;
  }

