#ifdef ROCKALL_DB_EXAMPLES
#define main Example_03_17
#endif

#include <stdio.h>

#include "DatabaseHeap.hpp"
#include "Example-03-04.hpp"
#include "RockallTypes.hpp"

int main( int Count,char *Argument[] )
  {
  DATABASE_HEAP Heap;

  if ( (Count == 2) && (Heap.CreateFile( Argument[1] )) )
    {
    if ( Heap.BeginTransaction() )
      {
      BASIC_CLASS *BasicClass;
      FILE_ADDRESS Address;

      if
          (
          (Heap.GetUserValue( 0,& Address ))
            &&
          (Heap.View( Address,((VOID**) & BasicClass) ))
          )
        { printf( "The value is %d\n",BasicClass -> Value ); }

      Heap.EndTransaction();
      }

    Heap.CloseFile();
    }

  return 0;
  }

