#ifdef ROCKALL_DB_EXAMPLES
#define main Example_05_07
#endif

#include "SingleThreadedHeap.hpp"
#include "Failure.hpp"
#include "RockallTypes.hpp"

BOOLEAN WalkFunction
    (
    BOOLEAN         Active,
    FILE_ADDRESS    Address,
    VOID            *Data,
    BOOLEAN         Destroy,
    FILE_SIZE       Space,
    VOID            *UserValue
    )
  {
  if ( Active )
    {
    FILE_SIZE *Size = ((FILE_SIZE*) UserValue);

    (*Size) += Space;
    }

  return True;
  }

int main( void )
  {
  SINGLE_THREADED_HEAP Heap;
  FILE_SIZE Size = 0;

  if ( ! Heap.Walk( WalkFunction,& Size ) )
    { FAILURE( "Unable to walk heap" ); }

  return 0;
  }

