#ifdef ROCKALL_DB_EXAMPLES
#define main Example_06_01
#endif

#include "AutomaticHeapScope.hpp"
#include "SingleThreadedHeap.hpp"
#include "Stack.hpp"

typedef SINGLE_THREADED_HEAP HEAP_TYPE;

int main( void )
  {
  HEAP_TYPE Heap;
  AUTOMATIC_HEAP_SCOPE<HEAP_TYPE> Scope( & Heap );
  STACK<HEAP_TYPE,NO_LOCK,int> Stack;
  int Result = 1;

  if ( Stack.PushValue( 0 ) )
    { Result = 0; }

  return Result;
  }

