#ifdef ROCKALL_DB_EXAMPLES
#define main Example_06_14
#endif

#include <stdio.h>

#include "AutomaticHeapScope.hpp"
#include "Queue.hpp"
#include "SingleThreadedHeap.hpp"

typedef SINGLE_THREADED_HEAP HEAP_TYPE;
typedef QUEUE<HEAP_TYPE,NO_LOCK,int> QUEUE_TYPE;

int main( void )
  {
  HEAP_TYPE Heap;
  AUTOMATIC_HEAP_SCOPE<HEAP_TYPE> Scope( & Heap );
  QUEUE_TYPE Queue;

  if ( Queue.PushValue( 1 ) )
    { printf( "New value stored in queue\n" ); }

  return 0;
  }
