#ifdef ROCKALL_DB_EXAMPLES
#define main Example_06_19
#endif

#include <stdio.h>

#include "AutomaticHeapScope.hpp"
#include "Set.hpp"
#include "SingleThreadedHeap.hpp"

typedef SINGLE_THREADED_HEAP HEAP_TYPE;
typedef SET<HEAP_TYPE,NO_LOCK,int> SET_TYPE;

int main( void )
  {
  HEAP_TYPE Heap;
  AUTOMATIC_HEAP_SCOPE<HEAP_TYPE> Scope( & Heap );
  SET_TYPE Set;

  if ( Set.NewValue( 1 ) )
    { printf( "New value stored in set\n" ); }

  return 0;
  }
