#include "DatabaseHeap.hpp"
#include "FixedString.hpp"
#include "NoLock.hpp"

typedef FIXED_STRING<DATABASE_HEAP,NO_LOCK,32> STRING;

typedef struct
  {
  STRING    HouseName;
  STRING    Street;
  STRING    District;
  STRING    City;
  STRING    County;
  STRING    Country;
  }
ADDRESS;

typedef struct
  {
  STRING    Forename;
  STRING    Surname;

  ADDRESS   Address[3];

  int       Age;
  STRING    DateOfBirth;
  int       MemberID;
  }
CUSTOMER;
